/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifndef __KIRAN_ACCOUNTS_GEN_H__
#define __KIRAN_ACCOUNTS_GEN_H__

#include <gio/gio.h>

G_BEGIN_DECLS


/* ------------------------------------------------------------------------ */
/* Declarations for com.kylinsec.Kiran.SystemDaemon.Accounts */

#define KIRAN_TYPE_ACCOUNTS (kiran_accounts_get_type ())
#define KIRAN_ACCOUNTS(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), KIRAN_TYPE_ACCOUNTS, KiranAccounts))
#define KIRAN_IS_ACCOUNTS(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), KIRAN_TYPE_ACCOUNTS))
#define KIRAN_ACCOUNTS_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), KIRAN_TYPE_ACCOUNTS, KiranAccountsIface))

struct _KiranAccounts;
typedef struct _KiranAccounts KiranAccounts;
typedef struct _KiranAccountsIface KiranAccountsIface;

struct _KiranAccountsIface
{
  GTypeInterface parent_iface;


  gboolean (*handle_create_user) (
    KiranAccounts *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_name,
    const gchar *arg_realname,
    gint arg_account_type,
    gint64 arg_uid);

  gboolean (*handle_delete_user) (
    KiranAccounts *object,
    GDBusMethodInvocation *invocation,
    guint64 arg_uid,
    gboolean arg_remove_files);

  gboolean (*handle_find_user_by_id) (
    KiranAccounts *object,
    GDBusMethodInvocation *invocation,
    guint64 arg_uid);

  gboolean (*handle_find_user_by_name) (
    KiranAccounts *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_name);

  gboolean (*handle_get_non_system_users) (
    KiranAccounts *object,
    GDBusMethodInvocation *invocation);

  void (*user_added) (
    KiranAccounts *object,
    const gchar *arg_user);

  void (*user_deleted) (
    KiranAccounts *object,
    const gchar *arg_user);

};

GType kiran_accounts_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *kiran_accounts_interface_info (void);
guint kiran_accounts_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void kiran_accounts_complete_get_non_system_users (
    KiranAccounts *object,
    GDBusMethodInvocation *invocation,
    const gchar *const *users);

void kiran_accounts_complete_find_user_by_id (
    KiranAccounts *object,
    GDBusMethodInvocation *invocation,
    const gchar *user);

void kiran_accounts_complete_find_user_by_name (
    KiranAccounts *object,
    GDBusMethodInvocation *invocation,
    const gchar *user);

void kiran_accounts_complete_create_user (
    KiranAccounts *object,
    GDBusMethodInvocation *invocation,
    const gchar *user);

void kiran_accounts_complete_delete_user (
    KiranAccounts *object,
    GDBusMethodInvocation *invocation);



/* D-Bus signal emissions functions: */
void kiran_accounts_emit_user_added (
    KiranAccounts *object,
    const gchar *arg_user);

void kiran_accounts_emit_user_deleted (
    KiranAccounts *object,
    const gchar *arg_user);



/* D-Bus method calls: */
void kiran_accounts_call_get_non_system_users (
    KiranAccounts *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean kiran_accounts_call_get_non_system_users_finish (
    KiranAccounts *proxy,
    gchar ***out_users,
    GAsyncResult *res,
    GError **error);

gboolean kiran_accounts_call_get_non_system_users_sync (
    KiranAccounts *proxy,
    gchar ***out_users,
    GCancellable *cancellable,
    GError **error);

void kiran_accounts_call_find_user_by_id (
    KiranAccounts *proxy,
    guint64 arg_uid,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean kiran_accounts_call_find_user_by_id_finish (
    KiranAccounts *proxy,
    gchar **out_user,
    GAsyncResult *res,
    GError **error);

gboolean kiran_accounts_call_find_user_by_id_sync (
    KiranAccounts *proxy,
    guint64 arg_uid,
    gchar **out_user,
    GCancellable *cancellable,
    GError **error);

void kiran_accounts_call_find_user_by_name (
    KiranAccounts *proxy,
    const gchar *arg_name,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean kiran_accounts_call_find_user_by_name_finish (
    KiranAccounts *proxy,
    gchar **out_user,
    GAsyncResult *res,
    GError **error);

gboolean kiran_accounts_call_find_user_by_name_sync (
    KiranAccounts *proxy,
    const gchar *arg_name,
    gchar **out_user,
    GCancellable *cancellable,
    GError **error);

void kiran_accounts_call_create_user (
    KiranAccounts *proxy,
    const gchar *arg_name,
    const gchar *arg_realname,
    gint arg_account_type,
    gint64 arg_uid,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean kiran_accounts_call_create_user_finish (
    KiranAccounts *proxy,
    gchar **out_user,
    GAsyncResult *res,
    GError **error);

gboolean kiran_accounts_call_create_user_sync (
    KiranAccounts *proxy,
    const gchar *arg_name,
    const gchar *arg_realname,
    gint arg_account_type,
    gint64 arg_uid,
    gchar **out_user,
    GCancellable *cancellable,
    GError **error);

void kiran_accounts_call_delete_user (
    KiranAccounts *proxy,
    guint64 arg_uid,
    gboolean arg_remove_files,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean kiran_accounts_call_delete_user_finish (
    KiranAccounts *proxy,
    GAsyncResult *res,
    GError **error);

gboolean kiran_accounts_call_delete_user_sync (
    KiranAccounts *proxy,
    guint64 arg_uid,
    gboolean arg_remove_files,
    GCancellable *cancellable,
    GError **error);



/* ---- */

#define KIRAN_TYPE_ACCOUNTS_PROXY (kiran_accounts_proxy_get_type ())
#define KIRAN_ACCOUNTS_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), KIRAN_TYPE_ACCOUNTS_PROXY, KiranAccountsProxy))
#define KIRAN_ACCOUNTS_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), KIRAN_TYPE_ACCOUNTS_PROXY, KiranAccountsProxyClass))
#define KIRAN_ACCOUNTS_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), KIRAN_TYPE_ACCOUNTS_PROXY, KiranAccountsProxyClass))
#define KIRAN_IS_ACCOUNTS_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), KIRAN_TYPE_ACCOUNTS_PROXY))
#define KIRAN_IS_ACCOUNTS_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), KIRAN_TYPE_ACCOUNTS_PROXY))

typedef struct _KiranAccountsProxy KiranAccountsProxy;
typedef struct _KiranAccountsProxyClass KiranAccountsProxyClass;
typedef struct _KiranAccountsProxyPrivate KiranAccountsProxyPrivate;

struct _KiranAccountsProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  KiranAccountsProxyPrivate *priv;
};

struct _KiranAccountsProxyClass
{
  GDBusProxyClass parent_class;
};

GType kiran_accounts_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KiranAccountsProxy, g_object_unref)
#endif

void kiran_accounts_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
KiranAccounts *kiran_accounts_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
KiranAccounts *kiran_accounts_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void kiran_accounts_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
KiranAccounts *kiran_accounts_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
KiranAccounts *kiran_accounts_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define KIRAN_TYPE_ACCOUNTS_SKELETON (kiran_accounts_skeleton_get_type ())
#define KIRAN_ACCOUNTS_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), KIRAN_TYPE_ACCOUNTS_SKELETON, KiranAccountsSkeleton))
#define KIRAN_ACCOUNTS_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), KIRAN_TYPE_ACCOUNTS_SKELETON, KiranAccountsSkeletonClass))
#define KIRAN_ACCOUNTS_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), KIRAN_TYPE_ACCOUNTS_SKELETON, KiranAccountsSkeletonClass))
#define KIRAN_IS_ACCOUNTS_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), KIRAN_TYPE_ACCOUNTS_SKELETON))
#define KIRAN_IS_ACCOUNTS_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), KIRAN_TYPE_ACCOUNTS_SKELETON))

typedef struct _KiranAccountsSkeleton KiranAccountsSkeleton;
typedef struct _KiranAccountsSkeletonClass KiranAccountsSkeletonClass;
typedef struct _KiranAccountsSkeletonPrivate KiranAccountsSkeletonPrivate;

struct _KiranAccountsSkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  KiranAccountsSkeletonPrivate *priv;
};

struct _KiranAccountsSkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType kiran_accounts_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KiranAccountsSkeleton, g_object_unref)
#endif

KiranAccounts *kiran_accounts_skeleton_new (void);


G_END_DECLS

#endif /* __KIRAN_ACCOUNTS_GEN_H__ */
